(*-----------#pc-version-----------------------------------------------------*)
(*
implementation
uses util,part,up,calctet,calctet1,sys;
*)
(*-----------#pc-version-----------------------------------------------------*)

(*-----------#unix-version-----------------------------------------------------*)
#include "syst.h"
#include "tt1.h"
#include "tt2.h"
#include "tt3.h"
#include "tt4.h"
#include "tt5.h"
#include "io.h"
#include "mon.h"
#include "util.h"
#include "rsutil.h"
#include "calctet.h"
#include "calctet1.h"
#include "sys.h"
#include "cspecial.h"
#include "up.h"
#include "part.h"
#include "cross.h"
#include "linbayes.h"
#include "testbuildm.h"

(*-----------#unix-version-----------------------------------------------------*)
procedure initialize;
label 999;
var count,i,j: integer; command: commands;
    filekind: filetype;

begin (* initialize *)
   trainandest:=true;
   testlow := 1; testhigh := 0; estlow := 1; esthigh := 0; 
   trainlow := 1; trainhigh := 0;
   initsamparray(samparray);
   twriteln(output,'Initializing Data Structures|');
   indep1 := nil;
   datamatinit;
   initev;
   maxtime := -1;
   new(statespace);
   tnewcov(truecor,stopprog);
   tnewcov(truecov,stopprog);
   firsttime := true;
   havereadgraph := false;
   havereadcov := false;
   havereadbayes := false;
   havereadraw := false;
   havereadcells := false;
   havereadlinearmodel := false;
   havereadindep := false;
   printpart := 0;
   currentin := inp;
   ll := true; mm := true; lm := true;  ml := true;
   singleconn := true; comm := true;
   acyclic := true; 
   for filekind := covarf to outputf do fileexists[filekind] := false;
   wantexit := false;
   count := 1;
   tnewedgenames(edgenames,stopprog);
   tnewadj(corrimpl,fatal);
   tnewcov(corrproba,fatal);
   tnewadj(path,fatal);
   tnewpairtoint(pairtoint,stopprog);
   tnewinttopair(inttopair,stopprog);
   tnewedgetovert(edgetovert,stopprog);
   tnewpaths(paths1,stopprog);        (* check for space *)
   tnewpaths(pathmatrix,stopprog);
   tnewtreks(treks1,stopprog);
   tnewadj(adjacency,stopprog);
   tnewadj(forbiddenadj,stopprog);
   tnewadj(commonfor,stopprog);
(*   tnewcov(initcov,stopprog); *)
   tnewcov(rho,stopprog);
   tnewcov(cov,stopprog);
   tnewcov(parm,stopprog);
   tnewcov(trueparm,stopprog);
   tnewcov(populcor,stopprog);
   new(cells);
   if stopprog in errors then goto 999;
   for i := 1 to maxvertex do
       for j := 1 to maxvertex do
	  begin
            cats[i].condprob := nil;
            vernames[i] := blankname;
	    rho^[i,j] := 0;
            cov^[i,j] := 0;
	    paths1^[i,j] := nil;
	    treks1^[i,j] := nil;
            pathmatrix^[i,j] := nil;
	    if i < j then
	       begin
    		  edgenames^[i,j] := count;
	          edgenames^[j,i] := count;
   	          edgetovert^[count].head := i;
	          edgetovert^[count].tail := j;
	          count := count + 1;
	       end;
	  end;
   initinput([null],true);
   lambda := 1.0;
   decpoints := 4;
   signif := 0.05;
   weight := 0.1;
   percent := 0.95;
   depth := -1;
   nochangedepth := -1;
   eqsnumber := 0;
   lisrelnumber := 0;
   graphfilename := nullfilename;
   ofilename := nullfilename;
   ifilename := nullfilename;
   knowfilename := nullfilename;
   numfilenames:=0;
   filenamelist:=nil;
   new(filenamelist);
   filenamelist^.next:=nil;
   initsuggested;
   models := nil;
   lastmodel := nil;
   candidates := nil;
   lastcand := nil;
   lisfilelist := nil;
   eqsfilelist := nil;
   varorder := nil;
   impbegin := nil;
   impend := nil;
   pageon := false;
   for command := finalsets to cequiv do
      begin
        commandneed[command] := [];
        if command in [tetrad,compareedge,scales,purify,
                       estimate,statwriter,makemodel,rocfile]
	then
              commandneed[command] := commandneed[command] + [agraph];
        if command in [tetrad,partial,compareedge,correlations,
                       scales,purify,regress] then
              commandneed[command] := commandneed[command] + [data];   
        if command in [tetrad,statwriter,compareedge,correlations,scales,purify,regress,gibbs,lrt] then
              commandneed[command] := commandneed[command] + [lineardata];   
        if command in [estimate,split,cross,rocfile] then
              commandneed[command] := commandneed[command] + [discretedata];
        if command in [finalsets,prttr,tetrad,compareedge,correlations,scales,purify,
                       partial,estimate,updatethenet,makemodel,readcon,regress,rocfile,gibbs,lrt,cequiv] then
              commandneed[command] := commandneed[command] + [fileforout];   
        if command in [updatethenet,addval,removeval,removeallval] then 
              commandneed[command] := commandneed[command] + [bayesnet];   
        if command in [monte,gibbs,lrt] then 
              commandneed[command] := commandneed[command] + [model];   
      end;
999: end; (* initialize *)

(*-----------#pc-version-----------------------------------------------------*)
(*end.*)
(*-----------#pc-version-----------------------------------------------------*)