(*-----------#pc-version-----------------------------------------------------*)
(* implementation uses sys; *)
(*-----------#pc-version-----------------------------------------------------*)

(*-----------#unix-version-----------------------------------------------------*)
#include "syst.h" 
#include "tt1.h" 
#include "tt2.h" 
#include "tt3.h"
#include "tt4.h" 
#include "tt5.h" 
#include "calctet.h" 
#include "calctet1.h" 
#include "cross.h" 
#include "util.h" 
#include "sys.h"
#include "io.h" 
#include "mon.h" 
#include "part.h" 
#include "rsutil.h"
#include "newcalc.h" 
#include "testbuildm.h" 
#include "linbayes.h"
#include "cspecial.h"
(*-----------#unix-version-----------------------------------------------------*)
(* 1.  Feb. 10, 1990.  Changed initsominput because vernames no longer
of length 2.  Changed output of partials. *)

const add = 1;
      remove = 2;
      reverse = 3;

type timearray = array[1..maxdepth] of double;
     deptharray = array[1..maxdepth] of integer;
     collidertype = record
	left,middle,right:integer;
       end;
     cstack = record
	collider: collidertype;
	next : ^cstack;
       end;
     cstackptr = ^cstack;
     estack = record
	head,tail:integer;
	next : ^estack;
       end;
     estackptr = ^estack;

pscoretype=record
	      pset : vertexset;
	      score : real;
	      next : ^pscoretype;
	   end;
   pscoretypeptr=^pscoretype;
   parentscorearray = array[1..maxvertex,0..10] of pscoretypeptr;

var numinlist,width: integer; numvisited,lastchecked,origscore: real;
    topscore: real; maxlevel: integer; forbiddenrev,forbiddenrem:
adjtype;
    endtime,starttime: timearray; lasttime: double;
zmodels,zlastmodel: modeltypeptr;

    newdebug:boolean;
   parentscore:parentscorearray;

procedure restoreispath(var ispath: adjtype; level: integer); var i,j:
vertextype; begin
   for i := 1 to max do
      for j := 1 to max do
        if (i in graphvertices) and (j in graphvertices) then
          if ispath^[i,j] = level then
             ispath^[i,j] := notthere; end;

function findmax(i,j: integer): integer; begin
  if i < j then findmax := j
  else findmax := i; end;

procedure formispath(var adjacency,ispath: adjtype; var cyclic:
boolean); var i,j,k: vertextype; begin
   cyclic := false;
   for i := 1 to max do
     for j := 1 to max do
       if (i in graphvertices) and (j in graphvertices) then
          if (i = j) then ispath^[i,j] := 0
          else ispath^[i,j] := adjacency^[i,j];
   for k:=1 to max do
      for i:=1 to max do
	 for j:=1 to max do
            if (i in graphvertices) and (j in graphvertices) and (k in
graphvertices) then
               if (ispath^[i,k] <> notthere) and (ispath^[k,j] <>
notthere) then
                 begin
                  ispath^[i,j] := findmax(ispath^[i,k],ispath^[k,j]);
                  if (i <> j) and (ispath^[j,i] <> notthere) then
cyclic := true;
                 end; end;

procedure checkcycle(head,tail: vertextype; var isacycle: boolean;
                     var adjacency,ispath: adjtype; level: integer);
label 999; var i,j: vertextype; begin
   isacycle := false;
   if head = tail then goto 999;
   for i := 1 to max do
      for j := 1 to max do
        if (i in graphvertices) and (j in graphvertices) then
          if (ispath^[i,head] <> notthere) and (ispath^[tail,j] <>
notthere) then
            begin
              if ispath^[i,j] = notthere then
                  begin
                     ispath^[i,j] := level;
                     if ispath^[j,i] <> notthere then
                         begin
                           isacycle := true;
                           goto 999;
                         end;
                  end;
           end; 999: end;

procedure zdisposemodellist(var amodel,lastmodel: modeltypeptr); (*
this procedure disposes of a list of models. *) label 999; var temp:
modeltypeptr;

begin (* disposemodellist *)
   lastmodel := nil;
   if amodel <> nil then
	 begin
	    temp := amodel^.fwd;
            while (amodel <> nil) do
	       begin
		  dispose(amodel);
		  amodel := temp;
		  if amodel <> nil then temp := amodel^.fwd
                  else goto 999;
	       end
	 end; (* if *) 999: end; (* disposemodellist *)

function zequalscore(score1,score2: real): boolean; begin
   zequalscore :=
       ((score1 >= 0) and
        ((score1 >= 0.99999 * score2) and (score1 <= 1.00001 *
score2))) or
       ((score1 < 0) and
        ((score1 <= 0.99999 * score2) and (score1 >= 1.00001 *
score2))); end;

function zlesscore(score1,score2: real): boolean; begin
   zlesscore :=
       (score1 >= 0) and (score1 <= 0.99999 * score2) or
       (score1 < 0) and (score1 <= 1.00001 * score2); end;

procedure zinsert(var model,curpos,list,listend: modeltypeptr;
                 after: boolean);
 begin
   if (curpos = nil) then
     begin
        if listend <> nil then
          begin
            listend^.fwd := model;
            model^.back := listend;
          end
        else list := model;
        listend := model;
     end
   else if after then
     begin
       if (curpos^.fwd <> nil) then curpos^.fwd^.back := model;
       model^.fwd := curpos^.fwd;
       model^.back := curpos;
       curpos^.fwd := model;
       if model^.fwd = nil then listend := model;
     end
   else
     begin
       if (curpos^.back <> nil) then curpos^.back^.fwd := model;
       model^.fwd := curpos;
       model^.back := curpos^.back;
       curpos^.back := model;
       if model^.back = nil then list := model;
     end;
 end;

procedure zinsertmodel(* var model,list,listend: modeltypeptr *);
label 999; var curpos: modeltypeptr; foundplace: boolean; begin
  numinlist := numinlist + 1;
  foundplace := false;
  if model <> nil then
    begin
       curpos := list;
       while (curpos <> nil) and (not foundplace) do
          begin
             if zlesscore(model^.score,curpos^.score) or
               (zequalscore(model^.score,curpos^.score)) then
                 begin
                      if curpos = nil then
                          if list = nil then
                            begin
                              zinsert(model,curpos,list,listend,true);
                              goto 999;
                            end
                          else curpos := list
                      else if (curpos^.fwd <> nil) then
                        curpos := curpos^.fwd
                      else if zequalscore(model^.score,curpos^.score)
or
                              (numinlist < 200) then
                         begin
                            zinsert(model,curpos,list,listend,true);
                            goto 999;
                         end
                      else
                         begin
                            dispose(model);
                            numinlist := numinlist - 1;
                            goto 999;
                         end;
                   end
            else foundplace := true;
        end;
   zinsert(model,curpos,list,listend,false);
  end; 999: end;

procedure zfindplace(var model,list,listend: modeltypeptr); var
curpos: modeltypeptr; foundplace: boolean; begin
  foundplace := false;
  if model <> nil then
    begin
       curpos := list;
       while (curpos <> nil) and (not foundplace) do
          begin
             if (model^.score > curpos^.score) or
                (model^.score = curpos^.score) then
                    begin
                      zinsert(model,curpos,list,listend,false);
                      foundplace := true;
                    end
              else curpos := curpos^.fwd;
            end;
       if (curpos = nil) then
zinsert(model,curpos,list,listend,false);
		                     
     end; end;

procedure zformcandidates(head,tail: integer;
	        var score,locscore1,locscore2: real;
                var candidates,lastcand: modeltypeptr;
                level,change: integer); var thismod: modeltypeptr;
i,j: integer;
 begin
    new(thismod);
    thismod^.fwd := nil; thismod^.back := nil;
    thismod^.score := score;
    thismod^.acc := locscore1;
    thismod^.sens := locscore2;
    thismod^.precision := change;
    thismod^.v1 := head; thismod^.v2 := tail;
    zfindplace(thismod,candidates,lastcand);
 end;

procedure zstoreresults1(head,tail: integer;
		        var currentmod,amodel: modeltypeptr;
			score: real; var models,lastmodel:
modeltypeptr); var thismod: modeltypeptr; i,j: integer; begin
   new(thismod);
   thismod^.score := score;
   thismod^.negpred := signif;
   thismod^.pospred := currentmod^.pospred;
   for i := 1 to max do
      thismod^.amodel[i] := currentmod^.amodel[i] + amodel^.amodel[i];
   zinsertmodel(thismod,models,lastmodel); end;

procedure getthemodscore(var lambda,locscore: real; j: vertextype);
begin
   if discrete then getmodscore(lambda,locscore,j)
   else getmodlinscore(lambda,locscore,j); end;

procedure zrttrcycler(var candidates,lastcand: modeltypeptr;
level:integer; var forbiddenadj: adjtype;
                      lambda: real; tail,head: vertextype; oldchange:
integer; oldlist: modeltypeptr); label 999; var gorttr: boolean; i,j:
integer; newscore,score,locscore1,locscore2: real;
    isacycle: boolean; curpos: modeltypeptr; change: integer;

   procedure initcycler;
      begin
        zdisposemodellist(candidates,lastcand);
        score := 0;
        for i := 1 to max do score := score + lscorearr[i];
      end;

   procedure changestate(change: integer; i,j: vertextype;
copy:			 boolean; locscore1,locscore2: real);
      begin
        if change = add then
            begin
               adjacency^[i,j] := level;
               theparents[j] := theparents[j] + [i];
               numparents[j] := numparents[j] + 1;
            end
        else if change = remove then
            begin
               adjacency^[i,j] := notthere;
               theparents[j] := theparents[j] - [i];
               numparents[j] := numparents[j] - 1;
            end
        else if change = reverse then
           begin
              adjacency^[i,j] := notthere;
              adjacency^[j,i] := level;
              theparents[j] := theparents[j] - [i];
              numparents[j] := numparents[j] - 1;
              theparents[i] := theparents[i] + [j];
              numparents[i] := numparents[i] + 1;
           end;
        if change = add then
checkcycle(i,j,isacycle,adjacency,ispath,level)
        else formispath(adjacency,ispath,isacycle);
        if (not isacycle) then
         begin
             if not copy then getthemodscore(lambda,locscore1,j);
             newscore := score - lscorearr[j] + locscore1;
             if change = reverse then
                begin
                   if not copy then
getthemodscore(lambda,locscore2,i);
                   newscore := newscore - lscorearr[i] + locscore2;
                end;
             if newscore > topscore then topscore := newscore;

zformcandidates(i,j,newscore,locscore1,locscore2,candidates,
                                lastcand,level,change);
         end (* else if change = add then
          begin
           if forbiddenadj^[i,j] = notthere then forbiddenadj^[i,j] :=
level + 1
          end
        else if change = reverse then
           if forbiddenrev^[i,j] = notthere then forbiddenrev^[i,j] :=
level + 1;*)
      end;

   procedure restorestate(change: integer; i,j: vertextype);
     begin

(* assumes that we never remove or reverse edge unless in original
graph *) (* assumes that we never remove or reverse edge unless in
original graph *)
       if change = add then
          begin
             adjacency^[i,j] := notthere;
             theparents[j] := theparents[j] - [i];
             numparents[j] := numparents[j] - 1;
          end
       else if change = remove then
          begin
             adjacency^[i,j] := 0;
             theparents[j] := theparents[j] + [i];
             numparents[j] := numparents[j] + 1;
          end
       else if change = reverse then
          begin
             adjacency^[i,j] := 0;
             adjacency^[j,i] := notthere;
             theparents[j] := theparents[j] + [i];
             numparents[j] := numparents[j] + 1;
             theparents[i] := theparents[i] - [j];
             numparents[i] := numparents[i] - 1;
          end;
       if change = add then restoreispath(ispath,level)
       else formispath(adjacency,ispath,isacycle); (* inefficient? *)
     end;

   procedure overtime;
      begin
       if maxtime <> -1 then
        if (tgettime - starttime[1]) > maxtime then
          begin
            errormess('Search aborted because time limits exceeded.|',fatal,false);
            twriteln(ofilvar,'Search aborted because time limits exceeded. |');
          end;
      end;

   procedure addtolist(i,j: vertextype; change: integer;
locscore1,locscore2: real; copy: boolean);
   begin
    if (i <> j) and (i in graphvertices) and (j in graphvertices) then
      begin
       overtime;
       if fatal in errors then goto 999;
       if (adjacency^[j,i] <> notthere) then
          if forbiddenadj^[i,j] = notthere then forbiddenadj^[i,j] :=
level;
       if (i <> j) and (i in graphvertices) and (j in graphvertices)
then
        begin
         if (change = add) and (adjacency^[i,j] = notthere) and (not
(i in temporder[j])) and
            ((forbiddenadj^[i,j] = notthere) or (level <
forbiddenadj^[i,j])) then
               begin
                changestate(add,i,j,copy,locscore1,locscore2);
                restorestate(add,i,j);
               end;
         if (change = remove) and (adjacency^[i,j] = 0) and
            ((forbiddenrem^[i,j] = notthere) or (level <
forbiddenrem^[i,j])) then
               begin
                changestate(remove,i,j,copy,locscore1,locscore2);
                restorestate(remove,i,j);
               end;
         if (change = reverse) and (adjacency^[i,j] = 0) and (not (j
in temporder[i])) and
            ((forbiddenrev^[i,j] = notthere) or (level <
forbiddenrev^[i,j])) then
               begin
                changestate(reverse,i,j,copy,locscore1,locscore2);
                restorestate(reverse,i,j);
               end;
        end;
      end;
    end;

begin (*rttrcycler*)
 initcycler;
 curpos := oldlist;
 while curpos <> nil do
    begin
      i := curpos^.v1;
      j := curpos^.v2;
      change := curpos^.precision;
      if (not(
              ((oldchange = reverse) and (change = reverse) and
               ((i = tail) or (i = head) or (j = tail) or (j = head)))
or
              ((oldchange = reverse) and (change <> reverse) and
               ((j = tail) or (j = head))) or
              ((oldchange <> reverse) and (change = reverse) and
               ((j = head) or (i = head))) or
              ((oldchange <> reverse) and (change <> reverse) and (j =
head)))) then
          addtolist(i,j,change,curpos^.acc,curpos^.sens,true);
      curpos := curpos^.fwd;
    end;
 if (tail = 0) and (head = 0) then
    for i := 1 to max do
        for j := 1 to max do
           begin
             addtolist(i,j,add,0,0,false);
             addtolist(i,j,remove,0,0,false);
             addtolist(i,j,reverse,0,0,false);
           end
 else
   begin
    for i:= 1 to max do
      for j := 1 to max do
        if (i <> j) and (i in graphvertices) and (j in graphvertices)
then
           begin
              if oldchange <> reverse then
                  begin
                     if j = head then addtolist(i,j,add,0,0,false);
                     if j = head then addtolist(i,j,remove,0,0,false);
                     if (i = head) or (j = head) then
addtolist(i,j,reverse,0,0,false);
                  end
              else
                  begin
                     if (j = tail) or (j = head) then
addtolist(i,j,add,0,0,false);
                     if (j = tail) or (j = head) then
addtolist(i,j,remove,0,0,false);
                     if (i = tail) or (j = tail) or (i = head) or (j =
head) then addtolist(i,j,reverse,0,0,false);
                  end;
          end;
   end; 999: end; (*rttrcycler*)

procedure zwritemod(var amodel: modelt; var ofilvar: text); var i,j:
vertextype; begin
   for i := 1 to max do
      for j := 1 to max do
        if (i in amodel[j]) then
           if (j in amodel[i]) and (i < j) then
              begin
                 pshort(i,ofilvar);
                 twrite(ofilvar,' -- |');
                 pshort(j, ofilvar);
                 twriteeoln(ofilvar);
              end
            else if (not (j in amodel[i])) then
              begin
                 pshort(i,ofilvar);
                 twrite(ofilvar,' -> |');
                 pshort(j, ofilvar);
                 twriteeoln(ofilvar);
              end
        
end;

procedure zwritemod1(var amodel: modelt; var ofilvar: text); var i,j:
vertextype; sofar: vertexset; begin
   sofar := [];
   for i := 1 to max do
      for j := 1 to max do
        if (i in amodel[j]) then
              begin
                 sofar := sofar + [i,j];
                 pshort(i,ofilvar);
                 twrite(ofilvar,' |');
                 pshort(j, ofilvar);
                 twriteeoln(ofilvar);
              end;
   for i := 1 to max do
      if (not (i in sofar)) then
        begin
           pshort(i, ofilvar);
           twriteeoln(ofilvar);
        end; end;

function comparepat(first,second: modeltypeptr): boolean; var i:
vertextype; begin
    comparepat := true;
    for i := 1 to max do
        if first^.amodel[i] <> second^.amodel[i] then comparepat :=
false; end;

procedure checkprev(var thebegin,theend: modeltypeptr); var
curpos,thenext: modeltypeptr; removeit,stop: boolean; begin
   removeit := false;
   curpos := thebegin;
   stop := false;
   while (curpos <> theend) and (not stop) do
     begin
       if comparepat(curpos,theend) then removeit := true;
       if removeit then
          begin
             curpos^.senscut := curpos^.senscut + 1;
             if curpos^.pospred > theend^.pospred then
                curpos^.pospred := theend^.pospred;
             if curpos^.negpred > theend^.negpred then
                curpos^.negpred := theend^.negpred;
          end;
       thenext := curpos^.fwd;
       if thenext = theend then stop := true
       else curpos := curpos^.fwd;
     end;
   if removeit then
      begin
         curpos^.fwd := theend^.fwd;
         dispose(theend);
         theend := curpos;
      end; end;

procedure converttopatterns(models: modeltypeptr); var
curpos1,curpos2: modeltypeptr; lastscore: real; begin
   curpos2 := models;
   curpos1 := models;
   lastscore := models^.score;
   while curpos2 <> nil do
      begin
         curpos2^.senscut := 1;
         convertmodtopat(curpos2);
         if abs(lastscore - curpos2^.score) > 0.01 then
            begin
               lastscore := curpos2^.score;
               curpos1 := curpos2;
            end;
         if curpos1 <> curpos2 then checkprev(curpos1,curpos2);
         curpos2 := curpos2^.fwd;
      end; end;

procedure zwritemodlist(models: modeltypeptr); label 999; var curpos:
modeltypeptr; gotparams: char;
    ch: char; numprinted,i,j,k: integer; topscore: real;
    comment: inbuf;
    stop: boolean; locfile: text; locfilename: inbuf;

procedure checkfortop; begin
       if (curpos^.score < origscore) then stop := true end;

begin (* locfilename := 'temp1|'; *)
    rewritefile(locfile,locfilename);
    twriteln(locfile,'/Graph|');
    if models <> nil then zwritemod1(models^.amodel,locfile); (*
twriteeoln(locfile); *)
    converttopatterns(models);
    numprinted := 0;
    curpos := models;
    if models <> nil then topscore := models^.score;
    stop := false;
    twriteeoln(ofilvar);
    twriteln(ofilvar,'/Independence|');
    while (curpos <> nil) and (not stop) do
      begin
       numprinted := numprinted + 1;
       checkfortop;
       zwritemod(curpos^.amodel,ofilvar);
       twrite(ofilvar,'!Equiv-score : |');
       twritereal(ofilvar,curpos^.score);
       twrite(ofilvar,' |');
       twritereal(ofilvar,curpos^.pospred);
       twrite(ofilvar,' |');
       twritereal(ofilvar,curpos^.negpred);
       twrite(ofilvar,' |');
       twritereal(ofilvar,curpos^.senscut);
       twriteeoln(ofilvar);
       twriteeoln(ofilvar);
       curpos := curpos^.fwd;
      end;
   twriteeoln(ofilvar);
   twritereal(ofilvar,numvisited);
   twriteeoln(ofilvar); 999: end;

procedure zfollowbranch(var models,lastmodel,amodel: modeltypeptr;
level,nochange: integer;
                       oldscore: real; forbiddenadj: adjtype;
                       var currentmod: modeltypeptr; numinskel:
integer;
                       lambda: real; oldtail,oldhead: vertextype;
oldchange: integer; oldlist: modeltypeptr); label 999; var
i,j,m,head,tail,bob: integer;
    candlist,endofcand,curcandidate,sendlist: modeltypeptr;
stop,resetdepth,isacycle,skipped: boolean;
    modelscore,neartoplevel: real; oldnochange,newlevel: integer;
    oldlocscore1,oldlocscore2,ratio,timenow,timesofar:real; change:
integer; oldnumvisited: real;
  
  procedure initzfollowbranch;
     begin
       candlist := nil; endofcand := nil;
       oldnochange := nochange;
       resetdepth := false;
       lastchecked := numvisited;
       starttime[level] := tgettime;
       stop := false;
       if maxtime <> -1 then
         if (maxtime <= timesofar) then
           begin
             errors := errors + [fatal];
             twrite(ofilvar,'Search aborted because time limits exceeded. |');
             twriteeoln(ofilvar);
           end;
      end;
   
   procedure endzfollowbranch;
   begin
      zdisposemodellist(candlist,endofcand);
      formispath(adjacency,ispath,isacycle);
   end;

   procedure writelocation;
     begin
       for bob := 1 to 3*(level-3) do twritechar(output,' ');
       writename(head,output);
       twrite(output,' -> |');
       writename(tail,output);
       if change = add then twrite(output,' added |')
       else if change = remove then twrite(output,' removed |')
       else if change = reverse then twrite(output,' reversed |');
       twritereal(output,curcandidate^.score);
       twriteeoln(output);
     end;

   procedure storeoldstate;
     begin
       head := curcandidate^.v1; tail := curcandidate^.v2;
       oldlocscore1 := lscorearr[tail];
       oldlocscore2 := lscorearr[head];
     end;
    
   procedure changestate;
   var k,l: vertextype;
     begin
       for k := 1 to max do
          for l := 1 to max do
             begin
                if (forbiddenadj^[k,l] > level) then
forbiddenadj^[k,l] := notthere;
                if (forbiddenrem^[k,l] > level) then
forbiddenrem^[k,l] := notthere;
                if (forbiddenrev^[k,l] > level) then
forbiddenrev^[k,l] := notthere;
             end;
       endtime[level] := tgettime;
       lscorearr[tail] := curcandidate^.acc;
       modelscore := curcandidate^.score;
       if (modelscore <= oldscore) and (nochange = oldnochange) then
           nochange := nochange + 1;
       if (modelscore > currentmax) then currentmax := modelscore;
       if change = add then
         begin
          amodel^.amodel[tail] := amodel^.amodel[tail] + [head];
          adjacency^[head,tail] := level;
          theparents[tail] := theparents[tail] + [head];
          numparents[tail] := numparents[tail] + 1;
          checkcycle(head,tail,isacycle,adjacency,ispath,level);
          if ((forbiddenadj^[head,tail] = notthere) or (level <
forbiddenadj^[head,tail])) then
              forbiddenadj^[head,tail] := level;
         end
       else if change = remove then
         begin
          currentmod^.amodel[tail] := currentmod^.amodel[tail] -
[head];
          adjacency^[head,tail] := notthere;
          theparents[tail] := theparents[tail] - [head];
          numparents[tail] := numparents[tail] - 1;
          formispath(adjacency,ispath,isacycle);
          if ((forbiddenrem^[head,tail] = notthere) or (level <
forbiddenrem^[head,tail])) then
              forbiddenrem^[head,tail] := level;
         end
       else if change = reverse then
          begin
             currentmod^.amodel[tail] := currentmod^.amodel[tail] -
[head];
             currentmod^.amodel[head] := currentmod^.amodel[head] +
[tail];
             adjacency^[head,tail] := notthere;
             adjacency^[tail,head] := level;
             theparents[tail] := theparents[tail] - [head];
             numparents[tail] := numparents[tail] - 1;
             theparents[head] := theparents[head] + [tail];
             numparents[head] := numparents[head] + 1;
             formispath(adjacency,ispath,isacycle);
             lscorearr[head] := curcandidate^.sens;
             if ((forbiddenrev^[head,tail] = notthere) or (level <
forbiddenrev^[head,tail])) then
                 forbiddenrev^[head,tail] := level;
          end;
     end;

   procedure writeabort;
     begin
       zwritemodlist(candlist);
       twrite(output,'Search aborted. |');
       twriteeoln(output);
       twrite(ofilvar,'Search aborted. |');
       twriteeoln(ofilvar);
     end;

   procedure restorestate;
     begin
       lscorearr[tail] := oldlocscore1;
       if change = add then
          begin
            adjacency^[head,tail] := notthere;
            theparents[tail] := theparents[tail] - [head];
            numparents[tail] := numparents[tail] - 1;
            amodel^.amodel[tail] := amodel^.amodel[tail] - [head];
            restoreispath(ispath,level);
          end
       else if change = remove then
          begin
            adjacency^[head,tail] := 0;
            theparents[tail] := theparents[tail] + [head];
            numparents[tail] := numparents[tail] + 1;
            currentmod^.amodel[tail] := currentmod^.amodel[tail] +
[head];
            formispath(adjacency,ispath,isacycle);
            lscorearr[tail] := oldlocscore1;
          end
       else if change = reverse then
          begin
            adjacency^[head,tail] := 0;
            adjacency^[tail,head] := notthere;
            theparents[tail] := theparents[tail] + [head];
            numparents[tail] := numparents[tail] + 1;
            theparents[head] := theparents[head] - [tail];
            numparents[head] := numparents[head] - 1;
            currentmod^.amodel[tail] := currentmod^.amodel[tail] +
[head];
            currentmod^.amodel[head] := currentmod^.amodel[head] -
[tail];
            formispath(adjacency,ispath,isacycle);
            lscorearr[tail] := oldlocscore1;
            lscorearr[head] := oldlocscore2;
          end;
       end;

begin {1}
  initzfollowbranch;
  if fatal in errors then goto 999;

zrttrcycler(candlist,endofcand,level,forbiddenadj,lambda,oldtail,oldhead,oldchange,oldlist);
  curcandidate := candlist;
  if candlist <> nil then
    if candlist^.score < oldscore then nochange := nochange + 1;
  skipped := false;
  sendlist := candlist;
  while (curcandidate <> nil) and (not stop) and (not aaabort) and
        ((depth = -1) or (level <= depth + 1)) do
     begin
           if (abs(curcandidate^.score - oldscore) < 0.001) or
              ((curcandidate^.score - oldscore) >=
                  (percent * (candlist^.score - oldscore))) and
               (curcandidate^.score > oldscore) then
           begin
              numvisited := numvisited + 1;
              oldnumvisited := numvisited;
              change := curcandidate^.precision;
              storeoldstate;
              changestate;
              writelocation;
              if ((level <= depth) or (depth = -1)) and
                ((nochange <= nochangedepth) or (nochangedepth = -1))
then

zfollowbranch(models,lastmodel,amodel,level+1,nochange,modelscore,forbiddenadj,

currentmod,numinskel,lambda,curcandidate^.v1,curcandidate^.v2,
                               curcandidate^.precision,sendlist);
              currentmod^.pospred := oldnumvisited;
              if (modelscore >= (oldscore - 0.1)) then

zstoreresults1(head,tail,currentmod,amodel,modelscore,models,lastmodel);
              restorestate;
            end
        else skipped := true;
        if percent = -1 then stop := true;
        if curcandidate^.score < (oldscore - 0.001) then stop := true;
        curcandidate := curcandidate^.fwd;
        if not skipped then sendlist := sendlist^.fwd;
     end; 999: if aaabort and (level = 2) then writeabort;
   endzfollowbranch; end; {1}

procedure zreadadjtomod(* var adjacency: adjtype;
			var currentmod: modeltypeptr *); var i,j:
vertextype; begin
  for i := 1 to max do
     begin
       currentmod^.amodel[i] := [];
       theparents[i] := [];
       numparents[i] := 0;
     end;
  for i := 1 to max do
     for j := 1 to max do
        if adjacency^[i,j] <> notthere then
          begin
             theparents[j] := theparents[j] + [i];
             numparents[j] := numparents[j] + 1;
             currentmod^.amodel[j] := currentmod^.amodel[j] + [i];
          end; end;


procedure getthescore(* var lambda,score: real *); begin
   if discrete then getscore(lambda,score)
   else getlinscore(lambda,score); end;

procedure zautosearch(* firsttime,lastone,ok: boolean; lambda: real;
*); label 999; var currentmod,amodel: modeltypeptr; i,j,k,l,numinskel:
integer; c: char;
    localadj: adjtype; isacycle: boolean;

   procedure initzauto;
      begin
         if (not discrete) then initlinear;
         numvisited := 0;
         candidates := nil;
         lastcand := nil;
         zmodels := nil;
         zlastmodel := nil;
         tnewadj(localadj,fatal); (* check for enough space *)
         tnewadj(ispath,fatal); (* check for enough space *)
         tnewadj(forbiddenrem,fatal);
         tnewadj(forbiddenrev,fatal);
         for i := 1 to max do
           for j := 1 to max do
             begin
              if adjacency^[i,j] <> notthere then adjacency^[i,j] :=
0;
              localadj^[i,j] := adjacency^[i,j];
              forbiddenadj^[i,j] := adjacency^[i,j];
              forbiddenrem^[i,j] := notthere;
              forbiddenrev^[i,j] := notthere;
             end;
         zdisposemodellist(zmodels,zlastmodel);
         numinlist := 0;
         getthescore(lambda,score);
         currentmax := score;
         topscore := score;
         starttime[1] := tgettime;
         lasttime := starttime[1];
         lastchecked := 1;
      end;

   procedure endzauto;
      begin (* dispose(localadj); *)
	  if (not discrete) then disposelinear;
          dispose(ispath);
          zwritemodlist(zmodels);
          if discrete then zdisposebayesnet(cats);
      end;

begin
   for j := 1 to max do
     begin
       theparents[j] := [];
       numparents[j] := 0;
     end;
   for i := 1 to max do
      for j := 1 to max do
         if adjacency^[i,j] <> notthere then
            begin
              theparents[j] := theparents[j] + [i];
              numparents[j] := numparents[j] + 1;
            end;
   if firsttime then initzauto;
   if (fatal in errors) or notok then goto 999;
   new(amodel);
   new(currentmod);
   getthescore(lambda,score);
   origscore := score;
   for i := 1 to max do
     begin
       amodel^.amodel[i] := [];
       currentmod^.amodel[i] := [];
       for j := 1 to max do
         forbiddenadj^[i,j] := adjacency^[i,j];
     end;
    zreadadjtomod(adjacency,currentmod);
    if score > topscore then topscore := score;
    zstoreresults1(1,2,currentmod,amodel,score,zmodels,zlastmodel);
    formispath(adjacency,ispath,isacycle);

zfollowbranch(zmodels,zlastmodel,amodel,3,0,score,forbiddenadj,currentmod,numinskel,lambda,0,0,1,nil);
         for i := 1 to max do
           for j := 1 to max do
              begin
                 adjacency^[i,j] := notthere; (* this needs to be
fixed so remembers *)
                 forbiddenadj^[i,j] := notthere;
                 forbiddenrem^[i,j] := notthere;
                 forbiddenrev^[i,j] := notthere;
             end; 999: if lastone then endzauto;
   errors := errors - [fatal]; end;


procedure writealist(amod: modeltypeptr); var curpos: modeltypeptr;
begin
   curpos := amod;
   while curpos <> nil do
      begin
        writename(curpos^.v1,output);
        twrite(output,' |');
        writename(curpos^.v2,output);
        twrite(output,' |');
        twritereal(output,curpos^.score);
        twrite(output,' |');
        twritereal(output,curpos^.sens);
        twrite(output,' |');
        twritereal(output,curpos^.acc);
        curpos := curpos^.fwd;
     end; end;

(*-----------#pc-version-----------------------------------------------------*)
(* end.  *)
(*-----------#pc-version-----------------------------------------------------*)




(* check a model to see if there is an edge from tail->head*)

function existarrowm(*cp:modeltypeptr;tail,head:integer):boolean;*);
begin
   existarrowm:= ((tail in cp^.amodel[head]) and not(head in
cp^.amodel[tail])); end;

(*check an adjacency matrix to see if there is an edge from
tail->head*) function
existarrowa(ladj:adjtype;tail,head:integer):boolean; begin
   existarrowa:= (ladj^[tail,head]<>notthere) and
(ladj^[head,tail]=notthere) end;

(*check an adjacency matrix to see if there is an undirected edge from
tail->head*)

function existedgea(ladj:adjtype;tail,head:integer):boolean; begin
   existedgea:= (ladj^[tail,head]<>notthere) and
(ladj^[head,tail]<>notthere) end;

function existedgem(*cp:modeltypeptr;head,tail:integer):boolean;*);
begin
   existedgem:= ((tail in cp^.amodel[head]) and (head in
cp^.amodel[tail])); end;

function noexistedgea(ladj:adjtype;head,tail:integer):boolean; begin
   noexistedgea:= (ladj^[tail,head]=notthere) and
(ladj^[head,tail]=notthere); end;

function noexistedgem(cp:modeltypeptr;head,tail:integer):boolean;
begin
   noexistedgem:= (not(tail in cp^.amodel[head]) and not (head in
cp^.amodel[tail])); end;

function adja(ladj:adjtype;v1,v2:integer):boolean; begin
   adja:= (ladj^[v1,v2]<>notthere) or (ladj^[v2,v1]<>notthere) end;

function adjm(*cp:modeltypeptr;v1,v2:integer):boolean;*); begin
   adjm:= ((v1 in cp^.amodel[v2]) or (v2 in cp^.amodel[v1])); end;

(* orients edge from tail -> head in model cp*) procedure
orientedge(cp:modeltypeptr;tail,head:integer); begin
   cp^.amodel[head]:=cp^.amodel[head] + [tail];
   cp^.amodel[tail]:=cp^.amodel[tail] - [head]; end;

procedure unorientedge(cp:modeltypeptr;tail,head:integer); begin
   cp^.amodel[head]:=cp^.amodel[head] + [tail];
   cp^.amodel[tail]:=cp^.amodel[tail] + [head]; end;

procedure removeedgemod(cp:modeltypeptr;tail,head:integer); begin
   cp^.amodel[head]:=cp^.amodel[head] - [tail];
   cp^.amodel[tail]:=cp^.amodel[tail] - [head]; end;

(* orients edge from tail -> head in adjacency matrix*) procedure
orienta(ladj:adjtype;tail,head:integer); begin
   ladj^[head,tail]:=notthere;
   ladj^[tail,head]:=0; end;


procedure cwritemodel(var ofile: text; amodel: modeltypeptr); var i,j:
vertextype; begin
    for i := 1 to (max-1) do
       if i in graphvertices then
          for j := (i+1) to max do
	   begin
             if existarrowm(amodel,j,i) then
                begin
                   writename(j,ofile);
                   twrite(ofile,' -> |');
                   writename(i,ofile);
                   twriteeoln(ofile);
                end;
             if existarrowm(amodel,i,j) then
                begin
                   writename(i,ofile);
                   twrite(ofile,' -> |');
                   writename(j,ofile);
                   twriteeoln(ofile);
                end;
             if existedgem(amodel,j,i) then
                begin
                   writename(j,ofile);
                   twrite(ofile,' -- |');
                   writename(i,ofile);
                   twriteeoln(ofile);
                end;
	   end;
(*    twriteeoln(ofile); *) end;




function R1(ladj:adjtype;a,b,c:integer):boolean; begin
  R1:=(existarrowa(ladj,a,b) and existedgea(ladj,b,c) and
noexistedgea(ladj,a,c)) end;

function R2(ladj:adjtype;a,b,c:integer):boolean; begin
  R2:=(existarrowa(ladj,a,b) and existarrowa(ladj,b,c) and
existedgea(ladj,a,c)); end;

function R3(ladj:adjtype;a,b,c,d:integer):boolean; begin
  R3:=(existarrowa(ladj,a,d) and existedgea(ladj,c,d) and
existedgea(ladj,a,b) and
	existedgea(ladj,b,c) and existedgea(ladj,b,d) and
noexistedgea(ladj,a,c)); end;

function R4(ladj:adjtype;a,b,c,d:integer):boolean; begin
  R4:=(existarrowa(ladj,d,a) and existedgea(ladj,d,c) and
existedgea(ladj,a,b) and
	existedgea(ladj,b,c) and adja(ladj,b,d) and
noexistedgea(ladj,a,c)); end;

function R1m(ladj:modeltypeptr;a,b,c:integer):boolean; begin
  R1m:=(existarrowm(ladj,a,b) and existedgem(ladj,b,c) and
noexistedgem(ladj,a,c)) end;

function R2m(ladj:modeltypeptr;a,b,c:integer):boolean; begin
  R2m:=(existarrowm(ladj,a,b) and existarrowm(ladj,b,c) and
existedgem(ladj,a,c)); end;

function R3m(ladj:modeltypeptr;a,b,c,d:integer):boolean; begin
  R3m:=(existarrowm(ladj,a,b) and existarrowm(ladj,c,b) and
existedgem(ladj,b,d) and
	adjm(ladj,c,d) and adjm(ladj,a,d) and noexistedgem(ladj,a,c)
and
	not(existarrowm(ladj,a,d) and existarrowm(ladj,c,d))); end;

function R4m(ladj:modeltypeptr;a,b,c,d:integer):boolean; begin
  R4m:=(existarrowm(ladj,a,b) and existarrowm(ladj,b,c) and
existedgem(ladj,d,c) and
	adjm(ladj,a,d) and adjm(ladj,b,d) and noexistedgem(ladj,a,c));
end;

function empty(stack:estackptr):boolean; begin
  empty:=(stack=nil); end;

function emptycollider(stack:cstackptr):boolean; begin
  emptycollider:=(stack=nil); end;

procedure pushedge(var stack:estackptr;tail,head:integer); var
stackelt:estackptr; begin
  new(stackelt);
  stackelt^.head:=head;
  stackelt^.tail:=tail;
  stackelt^.next:=stack;
  stack:=stackelt; end;

procedure popcollider(var stack:cstackptr;var
left,middle,right:integer); var tempptr:cstackptr; begin
  if not(emptycollider(stack)) then
     begin
	left:=stack^.collider.left;
	middle:=stack^.collider.middle;
	right:=stack^.collider.right;
	tempptr:=stack;
	stack:=stack^.next;
	dispose(tempptr);
     end; end;

procedure pushcollider(var stack:cstackptr;left,middle,right:integer);
var stackelt:cstackptr; begin
  new(stackelt);
  stackelt^.collider.left:=left;
  stackelt^.collider.middle:=middle;
  stackelt^.collider.right:=right;
  stackelt^.next:=stack;
  stack:=stackelt; end;

procedure pop(var stack:estackptr;var tail,head:integer); var
tempptr:estackptr; begin
  if not(empty(stack)) then
     begin
	head:=stack^.head;
	tail:=stack^.tail;
	tempptr:=stack;
	stack:=stack^.next;
	dispose(tempptr);
     end; end;

procedure findunshieldedcolliders( cp : modeltypeptr;
				  var col : cstackptr;
				      vset : vertexset); var i,j,k :
integer; begin
  for i:=1 to max do
     if i in vset then
    for j:=1 to (max-1) do
    if (existarrowm(cp,j,i) and (i<>j)) then
      for k:=(j+1) to max do
	if (existarrowm(cp,k,i) and noexistedgem(cp,j,k) and (j<>k)
and (i<>k)) then
	   pushcollider(col,j,i,k); end;


procedure algorithm1(ladj:adjtype); var new:estackptr;
    a,b,c,d:integer; begin new:=nil; for a:=1 to max do begin
  for c:=1 to max do
  if a<>c then
   for b:=1 to max do
     if ((b<>a) and (b<>c)) then
        for d := 1 to max do
	  if ((d<>a) and (d<>b) and (d<>c)) then
            if R3(ladj,a,b,c,d) then pushedge(new,d,b);
	    if R1(ladj,a,b,d) then begin
pushedge(new,d,b);orienta(ladj,b,d); end;
	    if R1(ladj,c,b,d) then begin
pushedge(new,d,b);orienta(ladj,b,d); end;
	    if R2(ladj,a,b,d) then pushedge(new,a,d);
	    if R2(ladj,c,b,d) then pushedge(new,c,d); end; while
not(empty(new)) do
  begin
	pop(new,a,b); (* a is the tail and b is the head ie a->b *)
	orienta(ladj,a,b);
	for c:=1 to max do
            if (adja(ladj,b,c) and (c<> a)) then
              begin
                if R1(ladj,a,b,c) then pushedge(new,a,c);
		if R2(ladj,a,b,c) then pushedge(new,a,c);
		if R2(ladj,c,a,b) then pushedge(new,c,b);
	      end;
   end; end;

procedure algorithm2(ladj:adjtype;a,b:integer); var new:estackptr;
    c,d:integer; begin orienta(ladj,a,b); new:=nil; for c:=1 to max do
  if (adja(ladj,c,b) and (c<>a)) then
    begin
	if R2(ladj,c,a,b) then begin
orienta(ladj,c,b);pushedge(new,c,b); end;
	if R2(ladj,a,b,c) then begin
orienta(ladj,a,c);pushedge(new,a,c); end;
	if R1(ladj,a,b,c) then
            begin
		orienta(ladj,b,c);pushedge(new,b,c);
		for d:=1 to max do
		  if (adja(ladj,a,d) and adja(ladj,d,b) and
R4(ladj,a,b,c,d)) then
			pushedge(new,d,c);
            end;
    end; while not(empty(new)) do
  begin
	pop(new,a,b); (* a is the tail and b is the head ie a->b *)
	orienta(ladj,a,b);
	for c:=1 to max do
            if (adja(ladj,b,c) and (c<> a)) then
              begin
                if R1(ladj,a,b,c) then pushedge(new,a,c);
		if R2(ladj,a,b,c) then pushedge(new,a,c);
		if R2(ladj,c,a,b) then pushedge(new,c,b);
	      end;
   end; end;

procedure algorithm1m(	 ladj : modeltypeptr;
		      col : cstackptr);
 var
   new	 : estackptr;
   a,b,c,d : integer;
   vset	 : vertexset;
   ncol	 : cstackptr; begin
   new:=nil;
   ncol:=nil;
   while not(emptycollider(col)) do
   begin
      popcollider(col,a,b,c);
      orientedge(ladj,a,b);
      orientedge(ladj,c,b);
      pushcollider(ncol,a,b,c);
   end;
   col:=ncol;
   while not(emptycollider(col)) do
    begin
       popcollider(col,a,b,c);
       for d := 1 to max do
	  if ((d<>a) and (d<>b) and (d<>c)) then
	     begin
		if R3m(ladj,a,b,c,d) then pushedge(new,d,b) else
		if R1m(ladj,a,b,d) then begin pushedge(new,b,d);orientedge(ladj,b,d); end else
		if R1m(ladj,c,b,d) then begin pushedge(new,b,d);orientedge(ladj,b,d); end;
		if R2m(ladj,a,b,d) then pushedge(new,a,d);
		if R2m(ladj,c,b,d) then pushedge(new,c,d);
		if R2m(ladj,d,a,b) then pushedge(new,d,b);
		if R2m(ladj,d,c,b) then pushedge(new,d,b);		
	     end;
    end;
   while not(empty(new)) do
   begin
      pop(new,a,b);  (* a is the tail and b is the head ie a->b  *)
	orientedge(ladj,a,b);
	for c:=1 to max do
            if (adjm(ladj,b,c) and  (c<> a)) then
              begin
                if R1m(ladj,a,b,c) then pushedge(new,b,c) else
		if R2m(ladj,a,b,c) then pushedge(new,a,c) else
		if R2m(ladj,c,a,b) then pushedge(new,c,b);
	      end;
   end;
end;

procedure algorithm2m(	  ladj : modeltypeptr;
		      a,b      : integer);
var
   new	: estackptr;
   c,d	: integer;
begin
   orientedge(ladj,a,b);
   new:=nil;
   for c:=1 to max do
      if (adjm(ladj,c,b) and (c<>a)) then
      begin
	 if R2m(ladj,c,a,b) then begin orientedge(ladj,c,b);pushedge(new,c,b); end;
	 if R2m(ladj,a,b,c) then begin orientedge(ladj,a,c);pushedge(new,a,c); end;
	 if R1m(ladj,a,b,c) then 
	 begin 
	    orientedge(ladj,b,c);pushedge(new,b,c);
	    for d:=1 to max do
	       if (adjm(ladj,a,d) and adjm(ladj,d,b) and R4m(ladj,a,b,c,d)) then
		  pushedge(new,d,c);
	 end;
      end;
   while not(empty(new)) do
   begin
      pop(new,a,b);  (* a is the tail and b is the head ie a->b  *)
      orientedge(ladj,a,b);
      for c:=1 to max do
	 if (adjm(ladj,b,c) and  (c<> a)) then
	 begin
	    if R1m(ladj,a,b,c) then pushedge(new,b,c) else
	    if R2m(ladj,a,b,c) then pushedge(new,a,c) else
	    if R2m(ladj,c,a,b) then pushedge(new,c,b);
	 end;
   end;
end;


procedure findpattern(*	  cp   : modeltypeptr;
		      vset     : vertexset*);
var
   col			 : cstackptr;
   left,middle,right,i,j : integer;
   mydebug		 : boolean;
begin
   mydebug:=false;
   col:=nil;
   findunshieldedcolliders(cp,col,vset);
   for i:=1 to (max-1) do
     for j:=(i+1) to max do
	if ((i<>j) and adjm(cp,i,j)) then unorientedge(cp,i,j);
   algorithm1m(cp,col);
   if mydebug then cwritemodel(output,cp);
end;


procedure findunord(ladj:adjtype;var unord:estackptr);
var i,j:integer;
begin
  for i := 1 to (max-1) do
   for j := (i+1) to max do
    if existedgea(ladj,i,j) then
       begin
	pushedge(unord,i,j);
	pushedge(unord,j,i);
       end;
end;

procedure myfindunord(	   ladj	 : modeltypeptr;
		      var unord : estackptr);
var i,j	: integer;
begin
   for i := 1 to (max-1) do
     for j := (i+1) to max do
	if existedgem(ladj,i,j) then
	begin
		 pushedge(unord,i,j);
		 pushedge(unord,j,i);
	end;
end;

procedure newfindunord(	   ladj	 : modeltypeptr;
		       var unord : estackptr;
			   a,b	 : integer);
var i,j	: integer;
begin
   if existedgem(ladj,a,b) then
   begin
      pushedge(unord,a,b);
      pushedge(unord,b,a);
   end;
   for i := 1 to (max-1) do
     for j := (i+1) to max do
	if existedgem(ladj,i,j) then
	begin
	   if not (((a=i) and (b=j)) or ((a=j) and (b=i))) then
	      begin
		 pushedge(unord,i,j);
		 pushedge(unord,j,i);
	      end;
	end;
end;


procedure finddag(* ladj:adjtype *);
var unord:estackptr;
    head,tail:integer;
begin
  algorithm1(ladj);
  unord:=nil;
  findunord(ladj,unord);
  while not(empty(unord)) do
    begin
	pop(unord,tail,head);
	pop(unord,tail,head);  (* pop two cause thats the way they are put into the list*)
        if existedgea(ladj,tail,head) then
		algorithm2(ladj,tail,head);		
    end;
end;

procedure myfinddag(ladj : modeltypeptr);
var
   unord      : estackptr;
    head,tail : integer;
begin
(*  algorithm1m(ladj);*)
  unord:=nil;
  myfindunord(ladj,unord);
  while not(empty(unord)) do
    begin
	pop(unord,tail,head);
	pop(unord,tail,head);  (* pop two cause thats the way they are put into the list*)
        if existedgem(ladj,tail,head) then
	   algorithm2m(ladj,tail,head);
    end;
end;


procedure newfinddag(	 ladj,lastadj : modeltypeptr;
		     i,j	      : integer);
var
   unord      : estackptr;
    head,tail : integer;
begin
(*  algorithm1m(ladj);*)
  unord:=nil;
  newfindunord(ladj,unord,i,j);
  while not(empty(unord)) do
    begin
	pop(unord,tail,head);
	pop(unord,tail,head);  (* pop two cause thats the way they are put into the list*)
        if existedgem(ladj,tail,head) then
		if existarrowm(lastadj,tail,head) then
		   algorithm2m(ladj,tail,head)
		else algorithm2m(ladj,head,tail);
    end;
end;


procedure getsavedscore2(var locscore  : real;
			     psetscore : pscoretypeptr;
			     pset      : vertexset;
			 var found     : boolean);
begin
   if psetscore <> nil then
      if psetscore^.pset=pset then
      begin
	 found:=true;
	 locscore:=psetscore^.score;
      end
      else
	 getsavedscore2(locscore,psetscore^.next,pset,found);
end;
			     
procedure getsavedscore(var locscore  : real;
			    vertex    : integer;
			    pset      : vertexset;
			var found     : boolean);
var
   n : integer;
begin
   found:=false;
   n:=sizeofset(pset);
   if n>= 10 then getsavedscore2(locscore,parentscore[vertex,10],pset,found)
   else getsavedscore2(locscore,parentscore[vertex,n],pset,found);
end;

procedure savescore(score  : real;
		    vertex : integer;
		    pset   : vertexset);
var
   psco	: pscoretypeptr;
   n	: integer;
begin
   new(psco);
   psco^.score:=score;
   psco^.pset:=pset;
   n:=sizeofset(pset);
   if n>=10 then
   begin
      psco^.next:= parentscore[vertex,10];
      parentscore[vertex,10]:=psco;
   end
   else
      psco^.next:= parentscore[vertex,n];
      parentscore[vertex,n]:=psco;
end;

procedure disposechain(psco :pscoretypeptr );
begin
   if psco<>nil then
   begin
      disposechain(psco^.next);
      dispose(psco);
   end;
end; { disposechain }

procedure initsavedscores;
var i,j	: integer;
begin
   for i:=1 to maxvertex do
      for j:=0 to 10 do
	 if parentscore[i,j]<>nil then
	 begin
	    disposechain(parentscore[i,j]);
	    parentscore[i,j]:=nil;
	 end;
   for i:=1 to maxvertex do
      for j:=0 to 10 do
	 parentscore[i,j]:=nil;
end;

(* gets score for a pattern with lambda as equivelant sample size*)

procedure getpatternscore(    cp	: modeltypeptr;
			  var score	: real;
			      lambda	: real;
			  var mmyfail	: boolean;
			      scoretype	:integer );
var
   tempcp   : modeltypeptr;
   mydebug  : boolean;
   i	    : integer;
   locscore : real;
   found    : boolean;
begin
   mydebug:=false;
   myfinddag(cp);
   readmodtoadj(adjacency,cp);   
   mmyfail :=  newiscycle(cp);
   if mydebug then begin
	new(tempcp);
	zreadadjtomod(adjacency,tempcp);
        twrite(output,'pattern|');
        twriteeoln(output);
	cwritemodel(output,cp);        
        twrite(output,'dag|');
        twriteeoln(output);
	cwritemodel(output,tempcp);
   end;
   if mmyfail then         twriteeoln(output)
      else
      begin
	 for i:=1 to max do
	 begin
	    locscore:=0;
	    getsavedscore(locscore,i,cp^.amodel[i],found);
	    if not(found) then
	    begin
	       if (scoretype=1) then
		  getthemodscore(lambda,locscore,i)
	       else entropymodscore(locscore,i);
	       savescore(locscore,i,cp^.amodel[i]);
	    end;
	    lscorearr[i]:=locscore;
	 end;
	 score:=0;
	 for i:=1 to max do
	    score:=score+lscorearr[i];
      end;
end;

procedure mygetpatternscore(*    cp	: modeltypeptr;
			  var score	: real;
			      lambda	: real;
			  var mmyfail	: boolean;
			      scoretype	:integer *);
var
   tempcp   : modeltypeptr;
   mydebug  : boolean;
   i	    : integer;
   locscore : real;
   found    : boolean;
begin
   mydebug:=false;
   myfinddag(cp);
   mmyfail :=  newiscycle(cp);
   if mmyfail then         twriteeoln(output)
      else
      begin
         if (scoretype = 1) then getthescore(lambda, score)
         else entropyscore(score);
      end;
end;

procedure newgetpatternscore(*	 cp	   : modeltypeptr;
			     var lastscore : real;
				 lambda	   : real;
			     var  lastdag  : modeltypeptr;
				 tail,head : integer;
				 firsttime : boolean;
			     var mmyfail	   : boolean;
			     scoretype:integer*);

var 
   mydebug,found    : boolean;
   locscore: real;
   i,j		    : integer;
begin
   mydebug:=false;  
   mmyfail:=false;
   newfinddag(cp,lastdag,tail,head);
   readmodtoadj(adjacency,cp);
   if newiscycle(cp) then mmyfail:=true;
   if mydebug then cwritemodel(output,cp);
   if not(mmyfail) then
      begin
	 if firsttime then if (scoretype=1) then
	    getthescore(lambda,locscore)
	 else entropyscore(locscore)
	 else
	 begin
	    for i:=1 to max do
	       if cp^.amodel[i]<>lastdag^.amodel[i] then
  	         begin
		   locscore:=0;
		   getsavedscore(locscore,i,cp^.amodel[i],found);
		   if not(found) then
		     begin
		       if (scoretype=1) then getthemodscore(lambda,locscore,i)
		       else entropymodscore(locscore,i);
       		       savescore(locscore,i,cp^.amodel[i]);
		     end;
		  lastscore:=lastscore - lscorearr[i] + locscore;  
		  lscorearr[i]:=locscore;
                 end;
	    copymodel(cp,lastdag);
	 end;
      end;
   if mydebug then writeln(lastscore);
end;

(* this procedure find the set of possible parents for a vertex j
 the set is empty of there is a directed edge into j
 otherwise the set is the set of adjacent vertices*)
procedure findpossiblepars(cp:modeltypeptr;j:integer;var pp:vertexset);
var i:integer;
    dir:boolean;
begin
  dir:=false;
  pp:=[];
  for i:=1 to max do
     if ((i<>j) and adjm(cp,i,j)) then
	begin
	   dir:=(dir or existarrowm(cp,i,j));
	   pp:=pp+[i];
	end;
  if dir then pp:=[];
end;


function cexpo(base,exponent:integer):real;
var temp: real; i: integer;
begin
  if base=0 then temp:= 0
  else if exponent<=0 then temp:= 1
  else if exponent > 0 then
     begin
        temp := 1;
        for i := 1 to exponent do temp := temp * base;
     end
  else 
     begin
        temp := 1;
        for i := -1 downto exponent do temp := temp/base;
     end;
  cexpo := temp;
end;


(* mainset is a set of size n and index is an integer from 0 to 2^n-1
 the procedure returns a subset of mainset (i.e. vset) corresponding
 to the index.*)
procedure decodetoset(var vset:vertexset;mainset:vertexset;index:integer);
var i,n,count:integer; 
begin
  n:=sizeofset(mainset);
  count:=0;
  vset:=[];
  for i := 1 to max do
    if i in mainset then
      begin
        count:=count+1;
        if index >= cexpo(2,(n-count)) then 
	    begin
		  vset:=vset+[i];
		  index:=index - round(cexpo(2,(n-count)));
	    end;
	  end;
end;

procedure writescore;
var score:real; 
    l:real;
begin
  twrite(output,'Score (lambda=10) : |');
  l:=10;
  getthescore(l,score);
  twritereal(output,score);
  twriteeoln(output);
  twriteeoln(output);
end;

(* this procedure find the best extension to a pattern
 of the pattern cp with the edge i-> j added.*)
procedure best(	   cp,newcp		     : modeltypeptr;
		   i,j			     : integer; 
	       var score1,maxscore,lastscore : real;
	       var possible		     : boolean;
		   lambda		     : real;
		   lastdag		     : modeltypeptr;
	       var colset		     : vertexset;
		   scoretype		     :integer );

var pp,temp,tempcol,bestcol : vertexset;  (*possible set of parrents for j*)
    n,index,v		    : integer;
    bestmod		    : modeltypeptr;
   bestscore		    : real;
   mmyfail			    : boolean;
begin
  if newdebug then
  begin
	twrite(output,'Adding edge |');
	writename(i,output);
	twrite(output,' -> |');
	writename(j,output);
	twriteeoln(output);
	twriteeoln(output);
  end;
  bestscore:=maxscore;
  new(bestmod);
  mmyfail:=false;
  findpossiblepars(cp,j,pp);
  n:=sizeofset(pp);
  for index:=0 to (round(cexpo(2,n))-1) do
     begin
	copymodel(cp,newcp);
	temp:=[];
        decodetoset(temp,pp,index);
	for v:= 1 to max do
	begin
	   if v in temp then orientedge(newcp,v,j)
	   else if v in pp then orientedge(newcp,j,v);
	end;
        orientedge(newcp,i,j);
	tempcol:=colset+[j];
        findpattern(newcp,tempcol);
        newgetpatternscore(newcp,lastscore,lambda,
			   lastdag,i,j,false,mmyfail,scoretype);
	if existedgem(newcp,i,j) then tempcol:=colset;
	score1:=bestscore;
        if not(mmyfail) then score1:=lastscore;
	if newdebug then 
	begin
		twriteln(output,'Model under consideration|');
		cwritemodel(output,newcp);
		twrite(output,'Score :|');
		twritereal(output,score1);
		twriteeoln(output);
		twrite(output,'_________________|');
		twriteeoln(output);
	end;
        if (not(mmyfail) and (score1>bestscore)) then 
          begin
	     copymodel(newcp,bestmod);
	     bestscore:=score1;
	     bestcol:=tempcol;
          end;
     end;
  if bestscore > maxscore then
     begin
	findpattern(bestmod,bestcol);
	copymodel(bestmod,newcp);
	score1:=bestscore;
	possible:=true;
	colset:=bestcol;
     end;
   dispose(bestmod);
end;


(* this procedure takes a  pattern and finds a pattern*)
procedure part1(    cp	      : modeltypeptr;
                    lambda    : real;
		var maxscore  : real;
		var colset    : vertexset;
		    scoretype : integer );
var
   newcp1,newcp2,bestcp	   : modeltypeptr;
   score1,score2,lastscore : real;
   possible,mydebug,mmyfail   : boolean;
   i,j,count		   : integer;
   lastdag		   : modeltypeptr;
begin
   mydebug:= true;
(*   newdebug:=false; *)
   count:=0;
   new(lastdag); for i:=1 to max do lastdag^.amodel[i]:=cp^.amodel[i];
   new(newcp1);for i:=1 to max do newcp1^.amodel[i]:=[];
   new(newcp2);for i:=1 to max do newcp2^.amodel[i]:=[];
   new(bestcp);for i:=1 to max do bestcp^.amodel[i]:=[];
   score1:=0;
   score2:=0;
   copymodel(cp,bestcp);   
   newgetpatternscore(cp,maxscore,lambda,lastdag,1,2,true,mmyfail,scoretype);
   possible:=true;
   lastscore:=maxscore;
   while possible do
      begin
	possible:=false;
	for i := 1 to max-1 do
	for j := i+1 to max do
	  if not(adjm(cp,i,j)) then
	  begin
	       best(cp,newcp1,i,j,score1,maxscore,lastscore,
		     possible,lambda,lastdag,colset,scoretype);
	       if not((cp^.amodel[i]=[])
		      and (cp^.amodel[j]=[])) then
		  best(cp,newcp2,j,i,score2,maxscore,lastscore,
		       possible,lambda,lastdag,colset,scoretype)
	       else score2:=score1-1;
	       if ((score1>score2) and (score1>maxscore)) then
	       begin
		  copymodel(newcp1,bestcp);
		  maxscore:=score1;
	       end
	       else if (score2 > maxscore) then
	       begin
		  copymodel(newcp2,bestcp);
		  maxscore:=score2;
	       end;
            end;
	if mydebug then 
	   begin
                twriteeoln(output);              
		twriteln(output,'Best model so far |');
		cwritemodel(output,bestcp);
		twriteln(output,'Score : |');
		twritereal(output,maxscore);
		twriteln(output,'_________________ |');
	   end;
	copymodel(bestcp,cp);
      end;
   dispose(lastdag);
   dispose(newcp1);
   dispose(newcp2);
   dispose(bestcp);
end;

procedure findpossiblecolliders(cp:modeltypeptr;var vset:vertexset;i,k:integer);
var j:integer;
begin
   vset:=[];
   for j:=1 to max do
	if (existedgem(cp,i,j) and existedgem(cp,k,j)) then vset:=vset+[j];
end;

procedure part2(    cp	      : modeltypeptr;
		    lambda    : real;
		var maxscore  : real;
		var colset    : vertexset;
		    scoretype :integer );
var
   newcp,bestcp:modeltypeptr;
   score:real;
   improve,mmyfail,mydebug:boolean;
   n,i,j,l,myindex:integer;
   vset,tempset,tempcol,bestcol:vertexset;

begin
   mydebug := true;
   new(newcp);
   new(bestcp);
   copymodel(cp,bestcp);
   improve:=true;
   mmyfail:=false;
   while improve do
   begin
    	improve:=false;
    	for i:=1 to (max-1) do
	   for j:= (i+1) to max do
	      if adjm(cp,i,j) then	      
	      begin
		 if newdebug then
		 begin
		    twrite(output,'Removing edge |');
		    writename(i,output);
		    twrite(output,' -- |');
		    writename(j,output);
		    twriteeoln(output);
		    twriteeoln(output);
		 end;
		 
		 tempcol:=colset;
		 copymodel(cp,newcp);
		 findpattern(newcp,tempcol);		 
		 removeedgemod(newcp,i,j);
		 findpattern(newcp,tempcol);
		 findpossiblecolliders(cp,vset,i,j);
		 n:=sizeofset(vset);
		 for myindex:=0 to (round(cexpo(2,n))-1) do
		 begin
		    tempset:=[];
		    decodetoset(tempset,vset,myindex);
		    for l:=1 to max do if l in tempset then
		    begin
		       orientedge(newcp,i,l);
		       orientedge(newcp,j,l);
		    end;
		    tempcol:=tempcol+[l];
		    findpattern(newcp,tempcol);
{		    if newdebug then cwritemodel(output,newcp);	}
		    getpatternscore(newcp,score,lambda,mmyfail,scoretype);
		    if (not(mmyfail) and newdebug) then
		    begin
		       twriteln(output,'Score : |');
		       twritereal(output,score);
		       twriteeoln(output);
		    end;
{		    if newdebug then cwritemodel(output,newcp);}
		    if (not(mmyfail) and (score>maxscore)) then
		       begin
			  copymodel(newcp,bestcp);
			  maxscore:=score;
			  bestcol:=tempcol;
			  improve:=true;
                	  if mydebug then 
 		  	     begin
		                twriteeoln(output);              
				twriteln(output,'Best model so far |');
				cwritemodel(output,bestcp);
				twriteln(output,'Score : |');
				twritereal(output,maxscore);
				twriteln(output,'_________________ |');
		  	     end;
		       end;
		    end;
		    for l:=1 to max do if l in tempset then
		       begin
			  unorientedge(newcp,i,l);
			  unorientedge(newcp,j,l);
		       end;
	      end;
      if improve then
      begin
	 copymodel(bestcp,cp);
	 colset:=bestcol;
      end;
   end;
   dispose(newcp);
   dispose(bestcp);
end;


procedure newsearch(* var adjacency: adjtype *);
var maxscore : real;
    i,j,k,l,scoretype	    : integer;
   colset	    : vertexset;
   mybuf	    : inbuf;
   gfile	    : text;
   boo		    : boolean;
   vset		    : vertexset;
begin
   if (not discrete) then initlinear;
   new(cp);for i:=1 to max do cp^.amodel[i]:=[];
   zreadadjtomod(adjacency,cp);
   twriteeoln(output);
   cwritemodel(output,cp);   
   twriteeoln(output);
   twriteeoln(output);
   if discrete then
      begin
        twriteln(output,'1) Bayesian BDe score|');
        twriteln(output,'2) Deviance score|');
        twriteeoln(output);
        twriteln(output,'Input number: |');
        flush(output);
        readttyline(buf);   
        scoretype:= round(readnum(false,fatal));
      end
   else 
     begin
      scoretype := 1;
      twriteln(output,'Using Bayesian BDe score|');      
     end;
   for i := 1 to max do colset:=colset + [i];
   findpattern(cp,colset);
   getpatternscore(cp,maxscore,lambda,boo,scoretype);		   
   twrite(output,'Score of initial model|');
   twritereal(output,maxscore);
   twriteeoln(output);
   flush(output);
   initsavedscores;
   part1(cp,lambda,maxscore,colset,scoretype);
   part2(cp,lambda,maxscore,colset,scoretype);

   
   findpattern(cp,colset);
   twrite(ofilvar,'Significance Level = |');
   twritereal(ofilvar,signif);
   twriteeoln(ofilvar);
   twriteln(ofilvar,'/PATTERN |');
   cwritemodel(ofilvar,cp);
   twriteeoln(ofilvar);
   twriteln(ofilvar,'Score : |');
   twritereal(ofilvar,maxscore);
   twriteln(ofilvar,'_________________ |');
   twriteeoln(output);
   cwritemodel(output,cp);   
   twriteeoln(output);
   twriteln(output,'Score : |');
   twritereal(output,maxscore);
   twriteln(output,'_________________ |');
   boo:=false;
   mybuf:='';   
   dispose(cp);
end;

procedure printpattern;
var
   i	  : integer;
   cp : modeltypeptr;
   colset : vertexset;
begin
   new(cp);
   zreadadjtomod(adjacency,cp);
   twriteln(output,'Dag |');
   cwritemodel(output,cp);
   twriteeoln(output);
   twriteeoln(output);
   for i := 1 to max do colset:=colset + [i];
   findpattern(cp,colset);   
   twriteln(output,'Pattern |');
   cwritemodel(output,cp);
   twriteeoln(output);
   twriteeoln(output); 
   dispose(cp);
end;   














