1. for each vertex and its adjacencies
     a. calculate whether collider, not, or not known for 
        each pair
     b. for each orientation of adjacencies
           1. calculate implied colliders
           2. compare with list 
           3. if best so far record

a. store adjacencies in set
b. in adjacency array mark as collider or not
c. store orientations in set - 
      in set if into, o.w. not in set 
d. store implied in adjacency


procedure getadjacencies(var ugraph: endarray; v: vertextype;
                         var adjset: vertexset;
                         var numadj: integer);
var i: vertextype;
begin
   numadj := 0;
   adjset := [];
   for i := 1 to max do
      if (i <> v) and ugraph^[i,v] <> [] then 
         begin
            adjset := adjset + [v];
            numadj := numadj + 1;
         end;
end;
      
procedure calccolliders(adjset: vertexset; v: vertextype;
                        var collide: adjtype;
                        var dsep: dseparray);
var i,j: vertextype;
begin
   for i := 1 to max do
     for j := 1 to max do
        if (i <> j) and (i in adjset) and (j in adjset)
           and (ugraph^[i,j] = []) then
              if v in dsep[i,j] then collide^[i,j] := 1
              else collide^[i,j] := 2
        else collide^[i,j] := 3;
end;

procedure calcimplied(orientset,adjset: vertexset; 
                      var collide: adjtype var thescore: integer);
var i,j: vertextype;
begin
  thescore := 0;
  for i := 1 to max do 
     for j := 1 to max do
        if (i <> j) and (i in adjset) and (j in adjset) then
           if (i in orientset) and (j in orientset) then
               if collide^[i,j] = 2 then
                  thescore := thescore + 1
               else if collide^[i,j] = 1 then 
                  thescore := thescore - 1
           else
               if collide^[i,j] = 1 then
                  thescore := thescore + 1
               else if collide^[i,j] = 2 then 
                  thescore := thescore - 1;
end;

procedure findbest(var orientset,bestorient: vertexset; 
                   var collide: adjtype;
                   var thescore,bestscore: integer);
begin
    calcimplied(orientset,adjset,collide,thescore);
    if thescore > bestscore then 
       begin
          bestscore := thescore;
          bestorient := orientset;
       end;
end;

procedure checkorientation(var orientset,adjset,bestorient: vertexset;
               var thescore,bestscore: integer;
               start,depth,numadj,v: integer;
               var collide: adjtype);
var i: integer;
begin                           
for i := start to max do
   begin
     if depth <> numadj then
        checkorientation(orientset,adjset,bestorient,
            thescore,bestscore,start+1,depth+1,numadj,v)
     else findbest(orientset,bestorient[v],collide,
                   thescore,bestscore);
     orientset := orientset + [i];
     if depth <> numadj then
        checkorientation(orientset,adjset,bestorient,
            thescore,bestscore,start+1,depth+1,numadj,v)
     else findbest(orientset,bestorient[v],collide,
                   thescore,bestscore);
   end;
end;

procedure setugraph(var bestorient: tempset; 
                    var ugraph: endarray);
var i,j: vertextype;
for i := 1 to max do
  for j := 1 to max do 
    if j in bestorient[i] then 
       begin
          ugraph^[i,j] := ugraph^[i,j] + [out2] - [notknown];
          ugraph^[j,i] := ugraph^[j,i] + [in2] - [notknown];
       end;
end;

procedure setcollider(dopropagate: boolean; var nocollidelist: triangleptr;
                      var nochange: boolean; var adj: adjtype);
var i,start,thescore,bestscore,numadj: integer;
    adjset,orientset: vertexset; bestorient: tempset;
    
for i := 1 to max do
  begin
    bestorient[i] := [];
    getadjacencies(ugraph,i,adjset,numadj);
    calccolliders(adjset,i,collide);
  end;
  orientset := [];
  start := 1;
  bestscore := 0;
  checkorientation(orientset,adjset,bestorient,start,thescore,bestscore,0,numadj,i,collide);
  end;
  setugraph(bestorient,ugraph);
  if dopropagate then
   for i := 1 to numob do
     for j := 1 to numob do
       for k := 1 to numob do
        if (i in graphvertices) and (j in graphvertices) and (k in graphvertices) then
         if (i <> j) and (j <> k) and (i <> k) then
           if ((in2 in ugraph^[i,j]) or (knownin2 in ugraph^[i,j])) and 
              (not (out2 in ugraph^[i,j])) and 
              (not (knownout2 in ugraph^[i,j])) and
              (ugraph^[j,k] <> []) and (not (out2 in ugraph^[j,k])) and 
              (not (knownout2 in ugraph^[j,k])) and
              (not (in2 in ugraph^[k,j])) and 
              (not (knownin2 in ugraph^[k,j])) and
              (ugraph^[i,k] =[]) then
                 if not causalsuff then
                    propagate(j,k,nocollidelist,true,adj)
                 else suffprop(j,k,adj);
end;

tnewadj(collide,fatal);
