(*-----------#pc-version-----------------------------------------------------*)
(*
implementation
uses io,rsutil,util,sys;
*)
(*-----------#pc-version-----------------------------------------------------*)

(*-----------#unix-version---------------------------------------------------*)
#include "syst.h"
#include "tt1.h"
#include "tt2.h"
#include "tt3.h"
#include "tt4.h"
#include "tt5.h"
#include "util.h"
#include "io.h"
#include "rsutil.h"
#include "cspecial.h"
#include "readco.h"
#include "mon.h"
#include "calctet1.h"
#include "sys.h"
#include "calctet.h"
(*-----------#unix-version---------------------------------------------------*)

(****************************************)
var
   samplecount : integer;

procedure myupdatecovs(var varval: vertarray; var cov: covarray);
   var i,j: integer;
   begin
     for i:= 1 to numob do
       begin
         smeans[i]:= smeans[i] + varval[i];
         for j:= i to numob do
           begin
             cov^[i,j]:= cov^[i,j] + (varval[i] * varval[j]);
             cov^[j,i]:= cov^[i,j];
           end;
       end; 
   end; 

  (* after all members of the sample have been generated, this
     converts sums to expectations. *)

procedure myfinishcovs(var cov: covarray);
   var i,j:integer;
   begin
     for i:= 1 to numob do
       smeans[i]:= smeans[i]/samplecount;
     for i:= 1 to numob do
       for j:= i to numob do
         begin
           cov^[i,j]:= cov^[i,j]/(samplecount - 1) - smeans[i]*smeans[j];
           cov^[j,i]:= cov^[i,j];
         end;
   end;

procedure getcontinuousdata(var cfin:text; var varval:vertarray; var datap:boolean);
label 999;
var val:real;
	i:integer;
begin
  datap := (not myeoln);
  if datap then
	begin
	  datap:=true;
	  for i := 1 to numob do 
	    begin
		val := readnum(false,fatal);
		if aaabort then goto 999;
		varval[i] := val;
	    end;
	end;
999: end;

procedure readrawcontinuous(* var cov,rho: covarray *);
label 999;
  var ofilename: inbuf; ofile,cfin: text;
      changed,datap: boolean;
      varval: vertarray;
      i,j : integer;
      c: char;
begin
  if not aaabort then
    begin
     readfileline(knowfile,buf);
     readwhitespace;
     readit(c);
     if c = '{' then 
        begin
          readcomment(knowfile);
          if myeoln then readfileline(knowfile,buf);
        end
     else curpos := curpos - 1;
     if (fatal in errors) then goto 999;
     sampsize := readnum(false,fatal);
     sampsize := tround(sampsize);
     if sampsize <=4 then
          myerror('Sample size must be greater than 4.|  ',fatal,true);
      checkend;
    end;
  readheader(numob,false);
  samplecount := 0;
  while not eof(knowfile) and (samplecount < sampsize) do
	begin
		datap:=false;
	   	getcontinuousdata(knowfile,varval,datap);
		if aaabort then goto 999;
		readfileline(knowfile,buf);
		if datap then
		   begin
			myupdatecovs(varval,cov);
			samplecount := samplecount + 1;
		   end;
	end;
	datap:=false;
   	getcontinuousdata(knowfile,varval,datap);
	if datap then
	   begin
		myupdatecovs(varval,cov);
		samplecount := samplecount + 1;
	   end;
  if samplecount < sampsize then 
     begin
        myerror('Number of lines of data less than specified sample size.|',
                 fatal,false);
        goto 999;
     end;
  myfinishcovs(cov);
  havereadcov := true;
  formcorrelations(rho);
999:  
end;

(*-----------#pc-version-----------------------------------------------------*)
(*end.*)
(*-----------#pc-version-----------------------------------------------------*)