(*-----------#pc-version-----------------------------------------------------*)

{$N+,E+,F+,O+}
(*
unit up;
interface
uses tt1,tt2,tt3,tt4,tt5;
*)
(*-----------#pc-version-----------------------------------------------------*)


type
   statespacetype=record
         size:integer;
          space:array[0..maxstatespace] of real;
      end;
   statespaceptr = ^statespacetype;
   observationlist = ^observation;
   observation = record
	next: observationlist;
	name: vertexnametype;
	number: vertextype;
	value: real;
	end;
   inttallycard = array[1..maxvertex, 1..maxcategories] of integer;
   realtallycard = array[1..maxvertex, 1..maxcategories] of real;

   updatemethods=(logicsampling,likelihoodweighting,analytic);

var
   updatemethod:updatemethods;
   lwtc : realtallycard;      {tallycard for counts in likelihood weighting}
   freqcard,ofreqcard : realtallycard; 
       {tallycards for relative frequencies in convergence}
   lsfreqcard,lwfreqcard : realtallycard;
   exactfreqcard : realtallycard;
       {'exact' frequencies for testing purposes}
   statespace:statespaceptr;
   evidencelist:observationlist;   {an ORDERED LINKED LIST of observations}
   evidenceset:vertexset;          {a set of vertices with observation values}
   likelihoodcount : real;   

procedure testevidence; external;
procedure updatebayesnetwork;external;
procedure updatebayes; external;
procedure addev; external;
procedure removeev; external;
procedure removeallevidence; external;
procedure initev; external;
procedure printev(var tofile: text);  external;
function hadevidence: boolean; external;
procedure addevidence(evidencelist: observationlist; var evidenceset:vertexset;
                      name: vertexnametype; number:vertextype; value:real);external;
procedure mse; external;
procedure getedgestrengths; external;
procedure getcrossentropy(var crossent1,crossent3: real); external;
function getlikelihoodscore(sample:vertarray;evidenceset:vertexset):real;external;
